<template>
  <v-container fluid fill-height>
    <v-layout align-center justify-center>
      <v-flex xs12 sm8 md4 v-show="!forgotPasswordForm">
        <v-card class="elevation-20" v-show="!createAccount">
          <v-form ref="form" @submit.prevent="connect">
            <v-toolbar dark extended extension-height="4" color="blue">
              <span class="headline black--text">Todo list</span>
              <v-spacer></v-spacer>
              <v-spacer></v-spacer>
              <v-spacer></v-spacer>
              <v-spacer></v-spacer>
              <v-img :src="require('@/assets/img/logo.jpg')" alt="Todo List logo" height="40" contain></v-img>
              <progress-bar
                :loading="isLoading"
                color="deep-purple accent-4"
                slot="extension"
              />
            </v-toolbar>
            <v-card-text>
              <v-text-field
                v-model="form.login"
               :rules="rules.form"
                prepend-icon="person"
                label="Login"
                id="login"
                type="text"
                required
                ></v-text-field>
              <v-text-field
                v-model="form.password"
                :rules="rules.form"
                prepend-icon="lock"
                :append-icon="showPassword ? 'visibility' : 'visibility_off'"
                :type="showPassword ? 'text' : 'password'"
                label="Password"
                id="password"
                required
                @click:append="showPassword = !showPassword"
              ></v-text-field>
              <a class="ml-1 caption" @click="forgotPasswordForm = true">Forgot password ?</a>
            </v-card-text>
            <v-card-actions>
              <v-btn v-on:click="createAccount = true"  color="primary" type="button">Create account</v-btn>
              <v-spacer></v-spacer>
              <v-btn :disabled="!formIsValid || loggingIn" color="primary" type="submit">Login</v-btn>
            </v-card-actions>
          </v-form>
        </v-card>
        <v-card class="elevation-20" v-show="createAccount">
          <v-form ref="createForm" @submit.prevent="create">
            <v-toolbar dark extended extension-height="4" color="blue">
              <span class="headline black--text">Todo list</span>
              <v-spacer></v-spacer>
              <v-spacer></v-spacer>
              <v-spacer></v-spacer>
              <v-spacer></v-spacer>
              <v-img :src="require('@/assets/img/logo.jpg')" alt="Todo List logo" height="40" contain></v-img>
              <progress-bar
                :loading="isLoading"
                color="deep-purple accent-4"
                slot="extension"
              />
            </v-toolbar>
            <v-card-text>
              <v-text-field v-model="createForm.login" :rules="rules.form" prepend-icon="person" label="Login" id="login2" type="text" required></v-text-field>
              <v-text-field v-model="createForm.mail" :rules="rules.emailRules" prepend-icon="mail" label="Email" id="email" type="text" required></v-text-field>
              <v-text-field
                v-model="createForm.password"
                :rules="rules.password"
                prepend-icon="lock"
                :append-icon="showPassword ? 'visibility' : 'visibility_off'"
                :type="showPassword ? 'text' : 'password'"
                label="Password"
                id="password2"
                required
                @click:append="showPassword = !showPassword"
              ></v-text-field>
              <v-text-field
                v-model="passwordConfirm"
                :rules="rules.passwordConfirm"
                prepend-icon="lock"
                :append-icon="showPassword ? 'visibility' : 'visibility_off'"
                :type="showPassword ? 'text' : 'password'"
                label="Repeat password"
                id="passwordConfirm"
                required
                @click:append="showPassword = !showPassword"
              ></v-text-field>
            </v-card-text>
            <v-card-actions>
              <v-btn v-on:click="createAccount = false" color="primary" type="button">Cancel</v-btn>
              <v-spacer></v-spacer>
              <v-btn color="primary" type="submit">Create account</v-btn>
            </v-card-actions>
          </v-form>
        </v-card>
      </v-flex><v-flex xs12 sm8 md4 v-show="forgotPasswordForm">
        <v-card class="elevation-20">
          <v-toolbar dark extended extension-height="4" color="blue">
            <span class="headline black--text">Todo list</span>
            <v-spacer></v-spacer>
            <v-spacer></v-spacer>
            <v-spacer></v-spacer>
            <v-spacer></v-spacer>
            <v-img :src="require('@/assets/img/logo.jpg')" alt="Todo List logo" height="40" contain></v-img>
            <progress-bar
              :loading="isLoading"
              color="deep-purple accent-4"
              slot="extension"
            />
          </v-toolbar>
          <v-stepper v-model="e6" vertical class="elevation-0 my-0 py-0" >
            <v-stepper-step :complete="e6 > 1" step="1">
              I'm not a robot
            </v-stepper-step>
            <v-stepper-content step="1">
              <v-card-text>
                <vue-recaptcha
                  ref="recaptcha"
                  v-on:verify="checkCaptchaResponse"
                  v-on:error="e6 = 1; forgotPasswordForm = false"
                  v-on:expired="e6 = 1"
                  sitekey="6Ld1s8YUAAAAAK-4arSP7Fgt5lUHZbWt1aGomtY9">
                </vue-recaptcha>
              </v-card-text>
            </v-stepper-content>
            <v-stepper-step :complete="e6 > 1" step="2">
              Check your account
            </v-stepper-step>
            <v-stepper-content step="2">
              <v-form ref="resetPasswordForm1" @submit.prevent="checkAccount()">
                <v-card-text class="pa-0">
                  <v-text-field v-model="resetPasswordForm1.login" :rules="rules.form" prepend-icon="person" label="Login" id="login3" type="text" required></v-text-field>
                  <v-text-field v-model="resetPasswordForm1.mail" :rules="rules.emailRules" prepend-icon="mail" label="Email" id="email3" type="text" required></v-text-field>
                </v-card-text>
                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn color="primary" type="submit">Check account</v-btn>
                </v-card-actions>
              </v-form>
            </v-stepper-content>
            <v-stepper-step :complete="e6 > 2" step="3">
              Change password
            </v-stepper-step>
            <v-stepper-content step="3">
              <v-form ref="resetPasswordForm2" @submit.prevent="resetPassword()">
                <v-card-text class="pa-0">
                  <v-text-field
                    v-model="resetPasswordForm2.password"
                    :rules="rules.password"
                    prepend-icon="lock"
                    :append-icon="showPassword ? 'visibility' : 'visibility_off'"
                    :type="showPassword ? 'text' : 'password'"
                    label="New password"
                    id="password3"
                    required
                    @click:append="showPassword = !showPassword"
                  ></v-text-field>
                  <v-text-field
                    v-model="passwordConfirm2"
                    :rules="rules.passwordConfirm2"
                    prepend-icon="lock"
                    :append-icon="showPassword ? 'visibility' : 'visibility_off'"
                    :type="showPassword ? 'text' : 'password'"
                    label="Repeat password"
                    id="passwordConfirm2"
                    required
                    @click:append="showPassword = !showPassword"
                  ></v-text-field>
                </v-card-text>
                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn color="primary" type="submit">Reset password</v-btn>
                </v-card-actions>
              </v-form>
            </v-stepper-content>
          </v-stepper>
          <v-card-actions>
            <v-btn v-on:click="e6 = 1;forgotPasswordForm = false"  color="primary" type="button">Cancel</v-btn>
            <v-spacer></v-spacer>
          </v-card-actions>
        </v-card>
      </v-flex>
    </v-layout>
  </v-container>
</template>

<script>
import progressBar from '@/components/NavBar/ProgressBar'

import AuthService from '@/services/AuthService'
import UserService from '@/services/UserService'
import ErrorService from '@/services/ErrorService'

import { mapGetters } from 'vuex'

import VueRecaptcha from 'vue-recaptcha'

export default {
  mounted () {
    this.$refs.form.$el.focus()
  },
  components: {
    'progress-bar': progressBar,
    VueRecaptcha
  },
  data () {
    const defaultForm = Object.freeze({
      login: '',
      password: ''
    })
    return {
      errorService: new ErrorService(),
      authService: new AuthService(),
      userService: new UserService(),
      authent: false,
      form: Object.assign({}, defaultForm),
      showPassword: false,
      defaultForm,
      createAccount: false,
      createForm: {},
      passwordConfirm: '',
      forgotPasswordForm: false,
      e6: 1,
      resetPasswordForm1: {},
      resetPasswordForm2: {},
      passwordConfirm2: ''
    }
  },

  computed: {
    ...mapGetters({
      loggingIn: 'auth/authenticated',
      userId: 'user/getId',
      isLoading: 'isLoading'
    }),
    rules: function () {
      return {
        password: [
          val => ((val || '').length > 0 && (val.length > 6 && val.length < 20)) || 'Must be between 6 and 20 characters.'
        ],
        passwordConfirm: [
          val => ((val || '').length > 0 && (val === this.createForm.password)) || 'Passwords must be identical.'
        ],
        passwordConfirm2: [
          val => ((val || '').length > 0 && (val === this.resetPasswordForm2.password)) || 'Passwords must be identical.'
        ],
        form: [
          val => (val || '').length > 0 || 'Required field'
        ],
        emailRules: [// eslint-disable-next-line
          v => v !== '' && /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(v) || 'Invalid format'
        ]
      }
    },
    formIsValid () {
      return (
        this.form.login &&
        this.form.password
      )
    }
  },

  watch: {
    lang (to, from) {
      // this.rules = this.initRules()
      this.rules.messages = { requiredField: 'Required field' }
      this.$refs.form.validate()
    },
    forgotPasswordForm (val) {
      if (val) {
        this.resetRecaptcha()
      }
    }
  },

  methods: {
    connect: function () {
      if (this.form.login === '' || this.form.password === '') {
        this.errorService.sendNotif('warn', 'Credential error', 'Fill the 2 fields.')
        return
      }
      this.$store.commit('loading', true)
      this.authService.signin(this.form).then((response) => {
        this.$store.dispatch('auth/authenticate', response.data)
        this.$store.commit('loading', false)
        this.$router.push({ name: 'Home' })
      }, (error) => {
        this.errorService.getServeurNotif(error.status, error.bodyText)
        this.$store.commit('loading', false)
      })
    },
    create: function () {
      if (!this.$refs.createForm.validate()) {
        return
      }
      this.$store.commit('loading', true)
      this.createForm.name = this.createForm.login
      this.authService.signup(this.createForm).then((response) => {
        this.$store.dispatch('alert/success', { content: 'Account created !' })
        this.$store.commit('loading', false)
        this.form.login = this.createForm.login
        this.$refs.form.resetValidation()
        this.form.password = ''
        this.createForm = {}
        this.createAccount = false
      }, (error) => {
        this.errorService.getServeurNotif(error.status, error.bodyText)
        this.$store.commit('loading', false)
      })
    },
    checkAccount: function () {
      if (!this.$refs.resetPasswordForm1.validate()) {
        return
      }
      this.$store.commit('loading', true)
      this.userService.checkUser(this.resetPasswordForm1).then((response) => {
        this.$store.commit('loading', false)
        this.resetPasswordForm2.login = this.resetPasswordForm1.login
        this.resetPasswordForm2.mail = this.resetPasswordForm1.mail
        this.resetPasswordForm1 = {}
        this.e6 = 3
      }, (error) => {
        this.errorService.getServeurNotif(error.status, error.bodyText)
        this.resetRecaptcha()
        this.$store.commit('loading', false)
        this.e6 = 1
      })
    },
    resetPassword: function () {
      if (!this.$refs.resetPasswordForm2.validate()) {
        return
      }
      this.$store.commit('loading', true)
      this.userService.resetPassword(this.resetPasswordForm2).then((response) => {
        this.$store.dispatch('alert/success', { content: 'Password changed' })
        this.$store.commit('loading', false)
        this.form.login = this.resetPasswordForm2.login
        this.resetRecaptcha()
        this.e6 = 1
        this.forgotPasswordForm = false
      }, (error) => {
        this.errorService.getServeurNotif(error.status, error.bodyText)
        this.$store.commit('loading', false)
        this.resetRecaptcha()
        this.e6 = 1
      })
    },
    checkCaptchaResponse: function (event) {
      this.resetPasswordForm2.token = event
      this.e6 = 2
    },
    resetRecaptcha () {
      this.$refs.recaptcha.reset()
      this.resetPasswordForm1 = {}
      this.resetPasswordForm2 = {}
    }
  }
}
</script>
